# FAQ

1. Появляется ошибка, в которой есть текст: "Неизвестный идентификатор формы". Это означает, что есть два или более epf файла, у которых совпадает поле **Имя** (это которое находится около Синонима и Комментария).

1. При открытии внешних обработок могут появляться окна с предупрждениями безопасти.
	* Если вы используете версию платформы 8.3.9.2033 или новее, тогда может появиться окно **Предупреждение безопасности**. 
	* Подробно этот механизм описан [здесь](http://its.1c.ru/db/v838doc#bookmark:dev:TI000001871).
	* Решение описано по [ссылке](https://github.com/xDrivenDevelopment/precommit1c#%D0%94%D0%BB%D1%8F-%D0%BA%D0%BE%D1%80%D1%80%D0%B5%D0%BA%D1%82%D0%BD%D0%BE%D0%B9-%D1%80%D0%B0%D0%B1%D0%BE%D1%82%D1%8B-%D0%BD%D0%B0-1%D0%A1-%D0%B2%D0%B5%D1%80%D1%81%D0%B8%D0%B8-8392016-%D0%B8-%D1%81%D1%82%D0%B0%D1%80%D1%88%D0%B5)
		* Кратко - Если хотите выключить этот механизм для всех баз - пропишите в файле conf.cfg строку: **DisableUnsafeActionProtection=.***

1. При пакетном запуске не загружаются и не выполняются фичи, открывается только форма `bddRunner`
	
	* У Вас неверный/устаревший/ json-файл настроек, несовместимый формат со штатным json, например, что читает 1С :frowning:
	* например:
		* одинарный слеш `\` не разрешен - используйте или `\\` или `/`
		* или одинарные кавычки \` или ’ не разрешены - используйте `\"`

	* Разбор проблемы в https://xdd.silverbulleters.org/t/pri-paketnom-zapuske-ne-zagruzhayutsya-i-ne-vypolnyayutsya-fichi-otkryvaetsya-tolko-bddrunner/2132

1. Как поставить точку останова (брейкпоинт) во внешней обработке для отладки?
	* Используйте штатный механизм отладки 1С, если у вас файловая база или клиент 1С и сервер 1С находятся на одной машине.
	* Если это не так, тогда более сложный путь:
		* Надо закрыть сеанс TestManager.
		* Надо открыть сеанс TestManager.
		* Надо открыть через меню `Файл / Открыть файл` обработку, в которой стоит точка останова.
		* Только после пункта 3 надо открыть bddRunner.epf.
		* Теперь остановка на точке остановки во внешнией обработке будет работать. Но до первого изменений кода в ней. Если изменили код, то надо повторить все действия с начала.

1. Как пропустить сценарий, чтобы он не падал?
	* Можно его закоментировать в тексте фичи (символ #)
	* Можно поставить сценарию тег - и использовать теги фильтры
	* Да пусть падает - тем более если он не реализован - то он будет желтым, а если реализован - тогда почему он падает? 

2. Как запустить фичу из поставки VB у себя в базе?
	* Большинство фич, которые идут в поставке VB, требуют, чтобы их запускали в специальной служебной базе.
	* Надо собрать служебную базу. Для этого надо загрузить CF из (**.\vanessa-behavoir\lib\CF\83**) 
	* Надо руками в базе установить константу **Путь к  Vanessa Behavior** - это полный путь к обработке **vanessa-behavior.epf** включая имя файла
	* Надо открыть в базе VB
	* Надо указать тег исключение **IgnoreOnCIMainBuild** (список исключаемых тегов)
	* Для ОФ надо ещё указать тег **IgnoreOnOFBuilds**
	* После этого можно загружать все фичи из каталога фич и запускать на выполнение.

3. Как мне удалить в транзакции созданные данные?
	* В BDD не обязательно их удалять за собой.
	* Если всё же хотите,  Вы можете гарантированно удалить их в процедуре **ПередОкончаниемСценария()**. Она срабатывает в любом случае, даже если сценарий упал.
	* Если создавались данные из макета **(Данные = Ванесса.СоздатьДанныеПоТабличномуДокументу(Макет))**, то можно использовать метод **Ванесса.УдалитьСозданныеДанные(Данные)**.
	* Лучше стремиться к тому, чтобы сценарий сам обеспечивал себе окружение, чтобы успешно выполниться.

4. Где мне лучше создавать служебные данные для выполнения сценария?
	* В секции Контекст feature файла
	* В процедуре **ПередНачаломСценария()**

5. Если в сценарии возникла ошибка, модальное окно и т.д. - как мне гарантированно закрыть все эти окна, чтобы следующий сценарий не падал?
	* В секции контекст надо добавить шаг **И Я закрыл все окна клиентского приложения**. А ещё лучше создать экспортный сценарий и в него добавить этот шаг. А в секции Контекст вызывать экспортный сценарий.

6. Как проверять поведение системы под разными ролями?
	* Надо запустить несколько TestClient на разных портах и переключаться между ними.

7. Как сохранять скриншоты при ошибках сценариев?

	Интерактивная настройка:
		+ Закладка `Сервис`
		+ далее `Автоинструкции`
		+ поле `Консольная команда создания скриншотов`
		  + после строки команды вставляется имя файла и в таком виде команда запускается!

	Можно устанавливать 
	+ как `NirCMD`
	+ http://www.nirsoft.net/utils/nircmd.zip
		+ команда `nircmd savescreenshot `

	+ так и `IrfanView`
		+ команда `"C:\Program Files (x86)\IrfanView\i_view32.exe" /capture=1 /convert=`

	+ Важно только устанавливать 32-разрядные версии !!

	Примеры json-файла настройки фиксации скриншотов
		для `NirCMD`:

```json
	"ДелатьСкриншотПриВозникновенииОшибки": true,
	"СниматьСкриншотКаждогоОкна1С": true,
	"КаталогOutputСкриншоты": "$workspaceRoot/build/out/ScreenShots",
	"КомандаСделатьСкриншот": "nircmd savescreenshot "
```

	или для `IrfanView`:

```json
	"ДелатьСкриншотПриВозникновенииОшибки": true,
	"СниматьСкриншотКаждогоОкна1С": true,
	"КаталогOutputСкриншоты": "$workspaceRoot/build/out/ScreenShots",
	"КомандаСделатьСкриншот": '"C:\Program Files (x86)\IrfanView\i_view32.exe" /capture=1 /convert='
```

1. На CI сервере скриншот формируется, но вместо изображения чёрный экран. Как настроить сервер CI?
	* Запускать джоб Jenkins в режиме сервиса нельзя. На CI надо настроить автовход под какой либо учётной записью и в автозагрузку надо поместить команду запуска джоба Jenkins.
	* Нельзя использовать для доступа к CI RDP. Вообще. Надо использовать другой софт для удаленного доступа к нему, например TightVNC. RDP полностью гасит видеокарту (виртуальную или настоящую) при отключении.
	* Надо посмотреть схему энерго сбережения в панели управления, там может стоять отключение дисплея через пару минут. Это надо выключить.

1. Почему у меня не работает тэг `@tree`
	* Для работы тега `@tree` надо использовать либо только табы, либо только пробелы. В пределах одной  фичи нельзя в отступах строк использовать и пробелы и Табы.

1. Я подключаюсь по RDP к серверу. И фича выполняется нормально, но если свернуть окно RDP, то возникает ошибка.
	* Это связано с особенностью платформы 1С. Некоторые методы платформы (кнопконажималки) не работают, когда погашена видеокарта (а RDP клиент её гасит, когда вы его сворачиваете). Поэтому не надо использовать RDP для доступа к CI (или другим) серверам, когда вы хотите использовать кнопконажималку.

1. Я вызвал метод Ванесса.ЗапретитьВыполнениеШагов(), затем я подключаю свой таймер, и мне надо сделать, чтобы шаг упал.
	* в этом случае вместо вызова исключения надо сделать Ванесса.ПродолжитьВыполнениеШагов(Истина)

1. Как использовать Sikuli-скрипты. 
	* Установите SikuliX согласно инструкции http://sikulix.com/quickstart/;
	* Ознакомьтесь с http://sikulix-2014.readthedocs.io/en/latest/faq/010-command-line.html;
	* Укажите через path путь к каталогу с runsikulix(.cmd);
	* Разрабатывайте свои Sikuli-скрипты с помощью SikuiliX IDE (http://sikulix-2014.readthedocs.io/en/latest/index.html) либо используйте имеющиеся;
	* Выполнение скрипта в реализации шага вызывайте через Ванесса.ВыполнитьSikuliСкрипт().

1. Как получить отчет Allure у себя на компьютере под Windows
	* Надо скачать дистрибутив Allure [отсюда](https://github.com/allure-framework/allure1/releases) 
	* Надо прописать в Path каталог где лежит allure.bat
	* Вызвать команду **call allure generate {каталог где лежат ваши xml в формате Allure}**
	* Вызвать команду **call allure report open**

1. Как при возникновении ошибки на CI получить скриншоты всех окон 1С?
	* Пока эта фича работает только под Windows.
	* Надо в json файле, в котором указываются параметры запуска Vanessa-Behavior, указать строку: `"СниматьСкриншотКаждогоОкна1С": "Истина"`
	* Надо установить на CI сервер java 8 (если у вас Jenkins - то скорее всего она у вас уже есть)
	* Надо установить SikuliX версии 1.1 или выше. Брать [отсюда](https://launchpad.net/sikuli/sikulix/1.1.1). Там надо скачать sikulixsetup-1.1.1.jar.
	* Надо чтобы файл runsikulix.cmd был прописан в переменной PATH.
